#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLEN 128

void prnPara ( char para[][MAXLEN] )
{
   int i;

   printf("\n");
   for (i=0; strlen(para[i])!=0; ++i) printf("%s\n", para[i]);
   printf("\n");
}

void rJustify ( char para[][MAXLEN], int T )
{
   int i, j, l;

   for (i=0; strcmp(para[i],""); ++i) {
      l = strlen(para[i]);
      if (l > T) {
         fprintf(stderr, "Line %d too wide to fit in %d characters\n", i, T);
         continue;
      }
      for (j=l-1; j>=0; --j) para[i][j+(T-l)] = para[i][j];
      for (j=0; j<T-l; ++j) para[i][j] = ' ';
      para[i][T] = '\0';
   }
}

int main ()
{
   char para[MAXLEN][MAXLEN];
   int i, l, T;

   printf("Enter lines one by one. Enter a blank line to terminate.\n");
   i = 0;
   while (1) {
      fgets(para[i], MAXLEN, stdin);
      l = strlen(para[i]);
      para[i][l-1] = '\0';
      if (!strcmp(para[i],"")) break;
      ++i;
   }
   printf("Enter a target width: "); scanf("%d", &T);

   prnPara(para);
   rJustify(para,T);
   prnPara(para);

   exit(0);
}
